;
;*******************************************************************
; 	BMON1048.H                    Date 22.12.2010
;	Battery Monitor with PIC18F2520
;       by Anja
;       An_ja  @  http://www.mikrocontroller.net
;*******************************************************************
;
; Taktfrequenz ca. 1.0 MHz mit internem RC-Oszillator bei 5V
;
;*******************************************************************
;
Clock	equ	1000000
Clock4  equ	Clock / 4
;
;*******************************************************************************
;
;	PINS
;
;*******************************************************************************
;
#define LoadON  LATB,6
#define ExtRef  LATA,1
#define DP1     LATB,5
#define DP2     LATB,1
#define Key     PORTA,4
;
;*******************************************************************************
;
;	MACROS
;
;*******************************************************************************
;
#define Cells   12
#define mV      * 256 * 51/1051 /1235
#define VOn     Cells * 1250 mV
#define VOff    Cells * 1150 mV
#define ms	* (Clock4 / 1000)
#define	us	* Clock4 / 1000000
#define VOLT_SEC 10             ; check every 10 seconds
#define VDIFF   600 mV          ;
#define mA      * 1
#define CURR_MIN 10 mA
NumLoop equ	4		; 4 clocks/loop
;
Delay	macro	Cycles		;	
CYC	set	Cycles/NumLoop	;
    if	CYC <= 255		;
	movlw	CYC		;
	call	Delay8		;
    else
CYC	set	(CYC+255)/256	;
	movlw	CYC		;
	call	Delay16		;
    endif
	endm
;
;*******************************************************************
; Variablen
;*******************************************************************
;
;
    CBLOCK 0x00         ; 
;
	HZ60		; Counter 60Hz
	TEMP		; Temp
        OldState        ;
        Volt            ; VBat
	Flags		;

        AARGB0          ;
        AARGB1          ;
        AARGB2          ;
        AARGB3          ;

        BARGB0          ;
        BARGB1          ;

        TEMPB0          ;
        TEMPB1          ;

        LCD0            ;
        LCD1            ;
        LCD2            ;
;
        SEGA            ;
        SEGB            ;
        SEGC            ;

        KeyDeb          ;
;
	VoltCou		; counter 10 seconds to check dU/dt
	VoltIdx		;
;
	VoltOld0	;
	VoltOld1	;
	VoltOld2	;
	VoltOld3	;
	VoltOld4	;
	VoltOld5	;
;
	Volt2		; old voltage for debouncing
;
	VoltH		; Voltage raw value H
        VoltL		;
;
	CurrH		; Current raw value H
	CurrL		;
; 
	Curr		; corrected current value
        CurrCou		;
;
	VoltCorrH	;
	VoltCorrL	;
	CurrCorrH	;
	CurrCorrL	;
;
    ENDC
;
;*******************************************************************
; Flag-Bits
;*******************************************************************
;
#define VoltOK	Flags,0
#define KeyOn   Flags,1
#define CurrOK  Flags,2
;
;
; Register-Bits
;
#define _c	STATUS,C ; Carry des Statusreg
;
;*******************************************************************
; 
